use strict;
use warnings;

sub ltrim { my $s = shift; $s =~ s/^\s+//;       return $s };

if (@ARGV != 3)
{
	print "You must have 3 arguments.  1st: new property file, 2nd: old property file and 3rd: Updated property file\n";
	exit 1;
}

my ($newFile, $oldFile, $updatedFile) = @ARGV;

open(templateFile, '<', $oldFile) or die("Could not open file '$oldFile': $!");
open(currentValues, '<', $newFile) or die("Could not open file '$newFile': $!");
open(my $updateFile, '>', $updatedFile) or die("Could not open file '$updatedFile': $!");

foreach my $line (<currentValues>)
 {
	# if line is blank write out newline and skip to next line
	if ( length(ltrim($line)) == 0 )
	{
		print $updateFile "\n";
	  # if line starts with a # then write out the comment and skip to next line
	} elsif ( substr(ltrim($line),0,1) eq "#" )
	 {
		print $updateFile $line;
	 }	
 
	else
	{
		# split property and value at equal sign
		(my $property, my $value) = split /=/, $line;
		# reset to top of file
		seek(templateFile, 0, 0); 
		my $foundit = "false";

		# search for property in old property file
		foreach my $tmpLine(<templateFile>) 
		{
			# skip any commented lines
			if ( substr(ltrim($tmpLine),0,1) ne "#" )
			{
				# if property is found in old property file then use that value
				if ($tmpLine =~ /$property=/)
				{
					$foundit ="true";
					#print $updateFile "# From original property file\n";
					print $updateFile $tmpLine;
					last;
				}
			}
		}
		# if property was not found in old property file then use the new value
		if ($foundit eq "false")
		{
			print $updateFile "# new property\n";
			print $updateFile $line;
		}
		
	}
}

# Now search for properties in the old but not in the new
seek(templateFile, 0, 0); 
my $newcount = 0;
foreach my $line (<templateFile>)
 {
	# if line is blank write out newline and skip to next line
	if ( length(ltrim($line)) == 0 )
	{
		# Do nothing 
		
	  # if line starts with a # then write out the comment and skip to next line
	} elsif ( substr(ltrim($line),0,1) eq "#" )
	 {
		# Do nothing
	 }	
 
	else
	{
		# split property and value at equal sign
		(my $property, my $value) = split /=/, $line;
		# reset to top of file
		seek(currentValues, 0, 0); 
		my $foundit = "false";

		# search for property in old property file
		foreach my $tmpLine(<currentValues>) 
		{
			# skip any commented lines
			if ( substr(ltrim($tmpLine),0,1) ne "#" )
			{
				# if property is found in old property file then use that value
				if ($tmpLine =~ /$property=/)
				{
					$foundit ="true";
					last;
				}
			}
		}
		# if property was not found in old property file then use the new value
		if ($foundit eq "false")
		{
			if ($newcount == 0)
			 {
			    print $updateFile "# old properties which were not found in new property file\n";
			 }
			print $updateFile $line;
			$newcount = $newcount + 1;
		}
		
	}
}

close templateFile;
close currentValues;
close $updateFile
